﻿using System.Drawing;
using System.Windows.Forms;
using System;

public class CheckableGroupBox : GroupBox
{
    private CheckBox checkbox;
    public event EventHandler CheckedChanged;

    public CheckableGroupBox()
    {
        checkbox = new CheckBox
        {
            Location = new Point(10, 0),
            AutoSize = true,
            Parent = this
        };
        checkbox.CheckedChanged += Checkbox_CheckedChanged;
    }

    public bool Checked
    {
        get { return checkbox.Checked; }
        set
        {
            if (checkbox.Checked != value)
            {
                checkbox.Checked = value;
                CheckedChanged?.Invoke(this, EventArgs.Empty);
            }
        }
    }

    public override string Text
    {
        get { return checkbox.Text; }
        set { checkbox.Text = value; }
    }

    private void Checkbox_CheckedChanged(object sender, EventArgs e)
    {
        foreach (Control control in Controls)
        {
            if (control != checkbox)
            {
                control.Enabled = checkbox.Checked;
            }
        }

        CheckedChanged?.Invoke(this, EventArgs.Empty);
    }
}